//------------------------------------------------------------------
#property link      "www.forex-tsd.com" 
#property copyright "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_color3  Blue
#property indicator_color4  Red
#property indicator_width3  2  
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern double Period1         =  12;
extern double Period2         =  12;
extern double Period3         =   3;
extern double Signal          =  12;
extern int    ColorOn         = 0;

extern bool   alertsOn        = true;
extern bool   alertsOnColor0  = true;
extern bool   alertsOnColor1  = false;
extern bool   alertsOnColor2  = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double tvi[];
double sig[];
double tvihuu[];
double tvihud[];
double tvibuu[];
double tvibud[];
double slope[];
double trend[];

//
//
//
//
//

string shortName;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(8);
   SetIndexBuffer(0,tvihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tvihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tvibuu); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,tvibud); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,tvi);
   SetIndexBuffer(5,sig);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trend);

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      timeFrame = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      shortName = timeFrameToString(timeFrame)+" Blau ergodic tick volume ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")";
      IndicatorShortName(shortName);   
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double trends[][3];
#define _tsi 0
#define _tsl 1
#define _tze 2

int start()
{
   int i,r,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { tvihuu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars); 
      for(i=limit,r=Bars-i-1; i>=0; i--,r++)
      {
         double upTicks = (Volume[i]+(Close[i]-Open[i])/Point) / 2.0;
         double dnTicks = (Volume[i] - upTicks);
         double avgUp = iEma(iEma(upTicks,Period1,i,0),Period2,i,1);
         double avgDn = iEma(iEma(dnTicks,Period1,i,2),Period2,i,3);
            if (avgUp+avgDn != 0)
                  tvi[i] = iEma(100.0*(avgUp-avgDn)/(avgUp+avgDn),Period3,i,4);
            else  tvi[i] = iEma(0                                ,Period3,i,4);                  
            sig[i] = iEma(tvi[i],Signal,i,5);                  

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
            trend[i] = trend[i+1];
               if (tvi[i] > tvi[i+1]) slope[i] =  1;
               if (tvi[i] < tvi[i+1]) slope[i] = -1;
               if (ColorOn==2)
               {
                  if (tvi[i]>sig[i]) trend[i] =  1;
                  if (tvi[i]<sig[i]) trend[i] = -1;
               }
               else
               {
                  if (tvi[i] > 0) trend[i] =  1;
                  if (tvi[i] < 0) trend[i] = -1;
               }
       
               //
               //
               //
               //
               //
                                         
               if (ColorOn==1)
                  if (slope[i]==1)
                        { tvihuu[i] = High[i]; tvihud[i] = Low[i]; tvibuu[i] = MathMax(Open[i],Close[i]); tvibud[i] = MathMin(Open[i],Close[i]); }
                  else  { tvihud[i] = High[i]; tvihuu[i] = Low[i]; tvibuu[i] = MathMin(Open[i],Close[i]); tvibud[i] = MathMax(Open[i],Close[i]); }
               else                  
                  if (trend[i]==1)
                        { tvihuu[i] = High[i]; tvihud[i] = Low[i]; tvibuu[i] = MathMax(Open[i],Close[i]); tvibud[i] = MathMin(Open[i],Close[i]); }
                  else  { tvihud[i] = High[i]; tvihuu[i] = Low[i]; tvibuu[i] = MathMin(Open[i],Close[i]); tvibud[i] = MathMax(Open[i],Close[i]); }
                  setTrends(i,r);
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   Comment(limit);
   if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars); 
   for(i=limit,r=Bars-i-1; i>=0; i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Signal,ColorOn,6,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Signal,ColorOn,7,y);
         if (ColorOn==1)
           if (slope[i]==1)
                 { tvihuu[i] = High[i]; tvihud[i] = Low[i]; tvibuu[i] = MathMax(Open[i],Close[i]); tvibud[i] = MathMin(Open[i],Close[i]); }
           else  { tvihud[i] = High[i]; tvihuu[i] = Low[i]; tvibuu[i] = MathMin(Open[i],Close[i]); tvibud[i] = MathMax(Open[i],Close[i]); }
         else                  
           if (trend[i]==1)
                 { tvihuu[i] = High[i]; tvihud[i] = Low[i]; tvibuu[i] = MathMax(Open[i],Close[i]); tvibud[i] = MathMin(Open[i],Close[i]); }
           else  { tvihud[i] = High[i]; tvihuu[i] = Low[i]; tvibuu[i] = MathMin(Open[i],Close[i]); tvibud[i] = MathMax(Open[i],Close[i]); }
           setTrends(i,r);
   }
   manageAlerts();
return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][6];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
} 

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void setTrends(int i, int r)
{
   trends[r][_tsi] = trends[r-1][_tsi];
   trends[r][_tsl] = trends[r-1][_tsl];
   trends[r][_tze] = trends[r-1][_tze];
   
      if (tvi[i]>sig[i])     trends[r][_tsi] =  1;
      if (tvi[i]<sig[i])     trends[r][_tsi] = -1;
      if (tvi[i] > tvi[i+1]) trends[r][_tsl] =  1;
      if (tvi[i] < tvi[i+1]) trends[r][_tsl] = -1;
      if (tvi[i] > 0)        trends[r][_tze] =  1;
      if (tvi[i] < 0)        trends[r][_tze] = -1; 
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 
                             whichBar = Bars-whichBar-1;

      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnColor2 && trends[whichBar][_tsi] != trends[whichBar-1][_tsi])
      {
         if (trends[whichBar][_tsi] ==  1) doAlert(time1,mess1,whichBar,"crossing signal up");
         if (trends[whichBar][_tsi] == -1) doAlert(time1,mess1,whichBar,"crossing signal down");
      }      
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnColor1 && trends[whichBar][_tsl] != trends[whichBar-1][_tsl])
      {
         if (trends[whichBar][_tsl] ==  1) doAlert(time2,mess2,whichBar,"sloping up");
         if (trends[whichBar][_tsl] == -1) doAlert(time2,mess2,whichBar,"sloping down");
      }
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnColor0 && trends[whichBar][_tze] != trends[whichBar-1][_tze])
      {
         if (trends[whichBar][_tze] ==  1) doAlert(time3,mess3,whichBar,"crossing zero up");
         if (trends[whichBar][_tze] == -1) doAlert(time3,mess3,whichBar,"crossing zero down");
      }
      
    }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," BlauErgodicTvi Candles ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," BlauErgodicTvi Candles "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}